//
//
//	Widget Media Player v2.2	05-Sep-2005
//	Design & Code: David Emmerson
//
//	Widget Media Player uses COM to access Windows Media Player functions and media library.
//	Inspired in parts by Arlo Rose's iTunes Remote.
//
//	See wmpReadme.txt for development notes.
//
//


	// create main player object and connect event listener
	try {
		var wmpPlayer = COM.createObject("WMPlayer.OCX");
		COM.connectObject( wmpPlayer, "wmpPlayer_" );
	} catch(e) {
		print(e.message);
	}

	// create player helper objects
	var wmpControls = wmpPlayer.controls;
	var wmpSettings = wmpPlayer.settings;
	var wmpCDromCollection = wmpPlayer.cdromCollection;

	var wmpMediaLibrary = new wmp_MediaLibrary();
	wmpMediaLibrary.refresh();
	
	// initialize player settings
	wmpSettings.autoStart = false;
	
	// initialize playlist array and index
	var wmp_playlistArray = new Array();
	var wmp_currentIndex = 0;

	// holds temp playlist for search results
	var tmpPlaylistArray = new Array();

	// holds drag & drop playlist
	var tmpDD_PlaylistArray = new Array();
	
	// holds displayed page of search results
	var wmp_searchResults = new Array();
	var pageCount = 0;
	var pageNumber = 0;

	// boolean flag for completed track
	var wmp_itemEnded = false;
	
	// timer strings
	var wmp_trackDuration = "";
	var wmp_trackPosition = "";
	var wmp_trackRemaining = "";

	// timer diplay defaults to remaining time
	wmp_timerDisplayType = 0;
	
	// array for holding timer animation objects
	var moveTimer = new Array();

	var isTimerAnimRunning = false;

	var isStartUp = true;
	getPlaylist(1);
	setPlaylist();
	var isStartUp = false;

	//****************************************//
	//       initialize volume slider         //
	//****************************************//
	function initVol() {

		// check player volume and set slider position
		var tVol = Number(preferences.volumeSetting.value);

		if ( tVol == 0 ) {
			wmpVolBtn.hOffset = 19;
			wmpSettings.volume = 0;	
		}  else if ( tVol == 100 ) {
			wmpVolBtn.hOffset = 209;
			wmpSettings.volume = 100;
		} else {
			wmpVolBtn.hOffset = Math.floor( (209 / 100) * tVol )
			wmpSettings.volume = tVol;
		}

		wmpVolBtn.opacity = 255;
	}
	
	//****************************************//
	//          drag volume slider            //
	//****************************************//
	function dragVol() {
		
		suppressUpdates();		

		// check that pointer is within horizontal bounds of slider
		if ( ( (system.event.hOffset - wmpVolPosXY) > 19 ) && ( (system.event.hOffset - wmpVolPosXY) < 209 ) ) {

			wmpVolBtn.hOffset = system.event.hOffset - wmpVolPosXY;
			wmpSettings.volume = Math.floor( (100 / 209) * wmpVolBtn.hOffset );
		
		// pointer at leftmost so zero slider/volume
		} else if ( (system.event.hOffset - wmpVolPosXY) <= 19 ) {

			wmpVolBtn.hOffset = 19;
			wmpSettings.volume = 0;

		// pointer at rightmost so full slider/volume
		} else if ( (system.event.hOffset - wmpVolPosXY) >= 209) {

			wmpVolBtn.hOffset = 209;
			wmpSettings.volume = 100;	
		}

		preferences.volumeSetting.value = wmpSettings.volume;
		savePreferences();

		resumeUpdates();

	}

	//****************************************//
	//        open/close info panel           //
	//****************************************//
	function doInfoPanelSlide() {
		
		suppressUpdates();
		
		if ( wmpIsInfoOn ) {

			wmpMediaLibraryWindow.visible = false;

			// turn info panel decorations off
			wmpTrackTitle.opacity = 0;
			wmpArtistName.opacity = 0;
			wmpAlbumTitle.opacity = 0;
	
			wmpInfoShine.fade(wmpInfoShine.opacity, 0, 2);

			// slide info panel out of sight
			wmpInfoPanel.slide("down", 100, 3);
			wmpInfoPanel.opacity = 0;


			wmpIsInfoOn = false;
	
		} else {
			
			// slide info panel into view
			wmpInfoPanel.opacity = 255;
			wmpInfoPanel.slide("up", 100, 3);

			// turn info panel decorations on
			wmpInfoShine.fade(wmpInfoShine.opacity, 255, 2);
	
			wmpTrackTitle.opacity = 255;
			wmpArtistName.opacity = 255;
			wmpAlbumTitle.opacity = 255;

			wmpMediaLibraryWindow.visible = true;

			wmpIsInfoOn = true;
			
		}

		resumeUpdates();

	}

	//****************************************//
	//           open/close player            //
	//****************************************//
	function resizePlayer() {
		
		wmpRightSideBtn.onMouseUp = "";
		wmpLeftSideBtn.onMouseUp = "";
		wmpRightSideBtn.opacity = 0;
		wmpLeftSideBtn.opacity = 0;

		updateNow();
		
		if ( wmpIsPlayerOpen ) {

			if ( wmpIsInfoOn ) { doInfoPanelSlide(); wmpInfoBtn.src="Resources/info_Exit.png"; }
			hideDecor(true);

			wmpLeftSide.opacity = 255;
			wmpRightSide.opacity = 255;		

			wmpBackground.opacity = 0;
			wmpLeftButton.opacity = 0;
			wmpRightButton.opacity = 0;
			wmpForeground.opacity = 0;
	
			wmpRightSide.slide("left",94,2);
			
			wmpRightSideBtn.src = "Resources/wmp_rs_right.png";
			wmpLeftSideBtn.src = "Resources/wmp_rs_left.png";
			wmpRightSideBtn.hOffset = 18;
			
			wmpIsPlayerOpen = false;
			
		} else {
	
			wmpRightSide.slide("right",94,2);
	
			wmpBackground.opacity = 255;
			wmpLeftButton.opacity = 255;
			wmpRightButton.opacity = 255;
			wmpForeground.opacity = 255;

			wmpLeftSide.opacity = 0;
			wmpRightSide.opacity = 0;

			hideDecor(false);

			wmpRightSideBtn.src = "Resources/wmp_rs_left.png";
			wmpLeftSideBtn.src = "Resources/wmp_rs_right.png";
			wmpRightSideBtn.hOffset = 251;

			wmpIsPlayerOpen = true;
		}

		wmpRightSideBtn.opacity = 255;
		wmpLeftSideBtn.opacity = 255;
		wmpRightSideBtn.onMouseUp = "resizePlayer();";
		wmpLeftSideBtn.onMouseUp = "resizePlayer();";

	}

	//****************************************//
	//         show/hide decorations          //
	//****************************************//
	function hideDecor( doHide ) {
		if ( doHide ) {

			hideTimer(doHide);		

			wmpVolBtn.slide("up", 100, 1);
			wmpVolBtn.opacity = 0;

			wmpInfoBtn.fade(wmpInfoBtn.opacity, 0, 0.5);
			wmpShuffleBtn.fade(wmpShuffleBtn.opacity, 0, 0.5);
			wmpLoopBtn.fade(wmpLoopBtn.opacity, 0, 0.5);
			wmpNextBtn.fade(wmpNextBtn.opacity, 0, 0.5);
			wmpPlayBtn.fade(wmpPlayBtn.opacity, 0, 0.5);
			wmpStopBtn.fade(wmpStopBtn.opacity, 0, 0.5);
			wmpPrevBtn.fade(wmpPrevBtn.opacity, 0, 0.5);
			wmpMuteBtn.fade(wmpMuteBtn.opacity, 0, 0.5);

		} else {
			
			wmpMuteBtn.fade(wmpMuteBtn.opacity, 255, 0.5);
			wmpPrevBtn.fade(wmpPrevBtn.opacity, 255, 0.5);
			wmpStopBtn.fade(wmpStopBtn.opacity, 255, 0.5);
			wmpPlayBtn.fade(wmpPlayBtn.opacity, 255, 0.5);
			wmpNextBtn.fade(wmpNextBtn.opacity, 255, 0.5);
			wmpLoopBtn.fade(wmpLoopBtn.opacity, 255, 0.5);
			wmpShuffleBtn.fade(wmpShuffleBtn.opacity, 255, 0.5);
			wmpInfoBtn.fade(wmpInfoBtn.opacity, 255, 0.5);

			wmpVolBtn.opacity = 255;
			wmpVolBtn.slide("down", 100, 1);

			hideTimer(doHide);

		}
	}

	function hideTimer( doHide ) {
		
		if ( doHide ) {

			wmpTimeShine.fade(wmpTimeShine.opacity, 0, 1);
			wmpTimeDisplayShadow.opacity = 0;
			wmpTimeDisplay.opacity = 0;

			wmpTimePanel.slide("down", 100, 1);
			wmpTimePanel.opacity = 0;

		} else {

			wmpTimePanel.opacity = 255;
			wmpTimePanel.slide("up", 100, 1);

			wmpTimeDisplay.opacity = 255;
			wmpTimeDisplayShadow.opacity = 255;
			wmpTimeShine.fade(wmpTimeShine.opacity, 255, 1);

		}
	}

	//****************************************//
	// COM.player state change event listener //
	//****************************************//
	function wmpPlayer_PlayStateChange( NewState ) {

		sleep(100);

		switch ( NewState ) {
		
			// finished playing item
			case 8:

				trackTimer.ticking = false;
				resetTrackTimer();

				wmpTrackTitle.data = "";
				wmpArtistName.data = "";
				wmpAlbumTitle.data = "";

				wmp_itemEnded = true;

				break;

			// player cue next track in playlist
			case 9:

				if ( wmpIsPlaying && wmp_itemEnded ) {

					wmp_itemEnded = false;
					wmp_currentIndex++;
					wmpPlayer__Play(0);

				}
				break;

			// playback started/resumed
			case 3:

				var fURL = wmpPlayer.URL;
				fURL = fURL.toLowerCase();
				fURLhttp = fURL.indexOf("http://");

				var fExt = wmpPlayer.currentMedia.getItemInfo("FileType");
				fExt = fExt.toLowerCase();

				if ( !( fURLhttp >= 0 || fExt == "asx" )) {
					trackTimer.ticking = true;
					sleep(500);
					startTrackTimer();
				} else { trackTimer.ticking = false }

				wmpTrackTitle.data = wmpPlayer.currentMedia.getItemInfo("Title");
				wmpArtistName.data = wmpPlayer.currentMedia.getItemInfo("Author");
				wmpAlbumTitle.data = wmpPlayer.currentMedia.getItemInfo("WM/AlbumTitle");

				break;

			// playback paused
			case 2:

				trackTimer.ticking = false;
				try {
					moveTimer[0].kill();
					moveTimer[1].kill();
					moveTimer[2].kill();
					moveTimer[3].kill();
				} catch(e) { print(e.message) }

				break;

			// playback stopped
			case 1:

				trackTimer.ticking = false;
				resetTrackTimer();

				wmpTrackTitle.data = "";
				wmpArtistName.data = "";
				wmpAlbumTitle.data = "";

				break;

			default:
				break;

		}
		
	}
	function wmpPlayer_Error() {
		var errorDesc = wmpPlayer.error.item(0).errorDescription;
		print(errorDesc);
	}
	//****************************************//
	//         custom play function           //
	//****************************************//
	function wmpPlayer__Play(intPlaylist) {
		
		// make sure play has stopped
		wmpControls.stop();
		
		if ( intPlaylist == 0 ) {

			// have we heard all the tracks
			if ( wmp_playlistArray.length == 0 ) {
				
				// reset playlist
				wmp_playlistArray = copyArray(tmpPlaylistArray);
	
				// see if we're looping
				if ( !wmpIsLoopPlay ) {
					wmpPlayBtn.src="Resources/play_Exit.png";
					return;
				}
			}
			
			// see if shuffle and get a random index
			if ( wmpIsShuffle ) { wmp_currentIndex = getRandomIndex() }
	
			// see if we've gone back before start of playlist
			else if ( wmp_currentIndex < 0 ) { wmp_currentIndex = (wmp_playlistArray.length - 1) }
	
			// see if we've gone past end of playlist
			else if ( wmp_currentIndex >= wmp_playlistArray.length ) { wmp_currentIndex = 0 }
			
			// get info for playlist item
			var itemInfo = wmp_playlistArray[wmp_currentIndex];
	
			// give path of playlist item to player
			wmpPlayer.URL = itemInfo[3];
			
			// remove track from playlist so we don't play it twice this loop
			if ( wmpIsShuffle ) { wmp_playlistArray.splice(wmp_currentIndex, 1) }

		} else {

			// get info for playlist item
			var itemInfo = tmpPlaylistArray[wmp_currentIndex];
	
			// give path of playlist item to player
			wmpPlayer.URL = itemInfo[3];
		}

		// start playback of track and set flag
		wmpControls.play();
		wmpIsPlaying = true;

	}

	//****************************************//
	//     process dropped file function      //
	//****************************************//
	function processDragDrop() {

		var fExtension;
		
		tmpDD_PlaylistArray = new Array();
		
		if (system.event.data[0] == "filenames") {

			for ( var i = 1; i < system.event.data.length; i++) {

				var tFilename = String(system.event.data[i]);
				tFilename = tFilename.toLowerCase();

				if ( filesystem.isDirectory(tFilename) ) {

					var aFilenames = filesystem.getDirectoryContents(tFilename);
					
					for (var n = 0; n < aFilenames.length; n++) {

						var aFile  = convertPathToPlatform(tFilename + "/" + aFilenames[n]);

						fExtension = aFile.substring(aFile.length - 3, aFile.length);

						if ( fExtension == "mp3" || fExtension == "wma" ) {

							var tItemInfo = new Array();
							var tItem = wmpMediaLibrary.getAudioPlaylist_Match("SourceURL", aFile)
							
							if ( tItem.length == 0 ) {
								tItemInfo = wmpMediaLibrary.addAudioItem(aFile);
							} else {
								tItemInfo = tItem[0];
							}
								
							tmpDD_PlaylistArray.push(tItemInfo);

						} else if ( fExtension == "cda" ) {

							tmpDD_PlaylistArray.push(new Array("", "", "", aFile));
						}
						
					}

				} else {

					fExtension = tFilename.substring(tFilename.length - 3, tFilename.length);

					if ( fExtension == "mp3" || fExtension == "wma" || fExtension == "asx" ) {
						
						var tItemInfo = new Array();
						var tItem = wmpMediaLibrary.getAudioPlaylist_Match("SourceURL", tFilename)
						
						if ( tItem.length == 0 ) {
							tItemInfo = wmpMediaLibrary.addAudioItem(tFilename);
						} else {
							tItemInfo = tItem[0];
						}
							
						tmpDD_PlaylistArray.push(tItemInfo);

					} else if ( fExtension == "cda" ) {

						tmpDD_PlaylistArray.push(new Array("", "", "", tFilename));
					}

				}
			}

		} else if (system.event.data[0] == "urls") {
			
			for ( var i = 1; i < system.event.data.length; i++) {

				var tURL = String(system.event.data[i]);
				tURL = tURL.toLowerCase();

				fExtension = tURL.indexOf(".asx");

				if ( fExtension > -1 ) {
					tmpDD_PlaylistArray.push(new Array("","","",tURL));
				}
			}
		}

		getPlaylist(5);
		
	}

	//****************************************//
	//        generate a random index         //
	//****************************************//
	function getRandomIndex() {

		// count items in playlist
		var numItems = wmp_playlistArray.length;

		// get a random number
		var randIndex = Math.random() * numItems;
		randIndex = Math.floor(randIndex);

		return randIndex;
	}
	
	//****************************************//
	//  get a playlist based on filter type   //
	//****************************************//
	function getPlaylist( listFilter ) {

		clearPage();
		pageCount = 0;
		pageNumber = 0;
		wmpSearchSummary.data = "Search results: 0";
		wmpPageCount.data = "Page 0 of 0";
		
		// get the search text
		var tSearch = wmpSearchText.data;
		tSearch = tSearch.toLowerCase();
		
		// pick a filter
		switch ( listFilter ) {
			
			case 1: // search for a song				
				tmpPlaylistArray = wmpMediaLibrary.getAudioPlaylist_Match("Title", tSearch);
				break;

			case 2: // search for an artist
				tmpPlaylistArray = wmpMediaLibrary.getAudioPlaylist_Match("Author", tSearch);
				break;

			case 3: // search for an album
				tmpPlaylistArray = wmpMediaLibrary.getAudioPlaylist_Match("WM/AlbumTitle", tSearch);
				break;

			case 4: // fetch a CDrom playlist
				tmpPlaylistArray = wmpMediaLibrary.getAudioPlaylist_CDrom(cdDrive);
				break;

			case 5: // drag & drop playlist
				tmpPlaylistArray = tmpDD_PlaylistArray;
				break;

			default:
				break;
		}

		// set pageCount
		pageCount = Math.floor(tmpPlaylistArray.length / 20) + (((tmpPlaylistArray.length % 20) > 0) ? 1 : 0);

		// show/hide buttons
		if ( tmpPlaylistArray.length > 0 ) {
			
			wmpPlaylistBtn.opacity = 255;

			if ( pageCount > 1 ) {
				wmpNextPageBtn.opacity = 255;
				wmpPrevPageBtn.opacity = 255;
			} else {
				wmpNextPageBtn.opacity = 0;
				wmpPrevPageBtn.opacity = 0;
			}
	
			// fetch page 1 to display
			getPage();

		} else {
			wmpPlaylistBtn.opacity = 0;
			wmpNextPageBtn.opacity = 0;
			wmpPrevPageBtn.opacity = 0;
		}
		
		// set search summary text
		wmpSearchSummary.data = "Search results: " + tmpPlaylistArray.length;

	}

	//****************************************//
	//      get page of search results        //
	//****************************************//
	function getPage() {
		
		clearPage();

		if ( tmpPlaylistArray.length > 0 ) {
			
			// wrap pages at ends
			if ( pageNumber > (pageCount - 1) ) { pageNumber = 0 }
			if ( pageNumber < 0 ) { pageNumber = pageCount - 1 }

			var itemCounter = 0;

			// set start and end items for page
			var pageStart = pageNumber * 20;
			var pageEnd = (pageNumber + 1) * 20;
			if ( pageEnd > tmpPlaylistArray.length ) { pageEnd = tmpPlaylistArray.length }

			for ( var i = pageStart; i < pageEnd; i++ ) {

				// get info for item
				var ml_itemInfo = tmpPlaylistArray[i];

				// make item and add to results page
				wmp_searchResults.push( new wmp_MediaLibraryItem( i, ml_itemInfo, itemCounter ) );

				itemCounter++;
			}
			
			// set page counter text
			wmpPageCount.data = "Page " + String(pageNumber + 1) + " of " + pageCount;
		}
		
	}

	//****************************************//
	//       clear search result page         //
	//****************************************//
	function clearPage() {
		
		// clear the page
		for ( var i = 0; i < 20; i++) {
			try {
				var tMLI = wmp_searchResults.pop();
				tMLI.removeItem();
				tMLI = null;
			} catch(e) {
				print(e.message);
			}
		}
	}

	//****************************************//
	//     set search results as playlist     //
	//****************************************//
	function setPlaylist() {
		wmp_playlistArray = copyArray(tmpPlaylistArray);
		wmpPlaylistBtn.opacity = 0;
	}

	function copyArray( arrayToCopy ) {
	  var temp_array = new Array();
	  for (var i = 0; i < arrayToCopy.length; i++)
	  {
	    temp_array[i] = copySubArray(arrayToCopy[i]);
	  }
	  return temp_array;
	}

	function copySubArray( subArrayToCopy ) {
	  var temp_array = new Array();
	  for (var i = 0; i < subArrayToCopy.length; i++)
	  {
	    temp_array[i] = subArrayToCopy[i];
	  }
	  return temp_array;
	}

	//****************************************//
	//         track time calculator          //
	//****************************************//
	function updateTimerDisplay() {
		
		if ( wmpPlayer.playState == 3 ) {

			// containers for times
			var timeRemainingUnits = new Array();
			var remainingSeconds = 0;
			
			var timeArray = getTrackTimeArray();
			var durationSeconds = timeArray[0];
			var positionSeconds = timeArray[1];

			// calculate remaining time and convert to hh:mm:ss
			remainingSeconds = (durationSeconds - positionSeconds);

			if ( remainingSeconds > 3600 ) {
				timeRemainingUnits[2] = String((remainingSeconds-((remainingSeconds-(remainingSeconds % 60)) / 60)) / 3600);
			}
			timeRemainingUnits[1] = String(((((remainingSeconds-(remainingSeconds % 60)) / 60) < 10) ? "0" : "") + ((remainingSeconds-(remainingSeconds % 60)) / 60));
			timeRemainingUnits[0] = String((((remainingSeconds % 60) < 10) ? "0" : "") + (remainingSeconds % 60));

			wmp_trackRemaining = ((timeRemainingUnits[2]) ? timeRemainingUnits[2] + ":" : "") + timeRemainingUnits[1] + ":" + timeRemainingUnits[0];

			// display result time string
			switch (wmp_timerDisplayType) {
				
				default:
					if ( wmp_trackRemaining == "NaN:NaN" ) { wmp_trackRemaining = "" }
					wmpTimeDisplay.data = wmp_trackRemaining;
					wmpTimeDisplayShadow.data = wmp_trackRemaining;
					break;
				case 1:
					wmpTimeDisplay.data = wmp_trackPosition;
					wmpTimeDisplayShadow.data = wmp_trackPosition;
					break;
				case 2:
					wmpTimeDisplay.data = wmp_trackDuration;
					wmpTimeDisplayShadow.data = wmp_trackDuration;
					break;
			}

		} else {
	
			wmp_trackDuration = "";
			wmp_trackPosition = "";
			wmp_trackRemaining = "";

		}
	
	}

	//****************************************//
	//       get time info in seconds         //
	//****************************************//
	function getTrackTimeArray() {

		var timeArray = new Array();

		// containers for times
		var timeDurationUnits = new Array();
		var timePositionUnits = new Array();

		var durationSeconds = 0;
		var positionSeconds = 0;


		// get track duration and calculate seconds
		wmp_trackDuration = wmpPlayer.currentMedia.durationString;
		timeDurationUnits = wmp_trackDuration.split(":");

		if ( timeDurationUnits.length > 2 ) {
			durationSeconds = Number(timeDurationUnits[0] * 3600) + Number(timeDurationUnits[1] * 60) + Number(timeDurationUnits[2]);
		} else {
			durationSeconds = Number(timeDurationUnits[0] * 60) + Number(timeDurationUnits[1]);
		}

		// get track position and calculate seconds
		wmp_trackPosition = wmpControls.currentPositionString;
		timePositionUnits = wmp_trackPosition.split(":");
	
		if ( timePositionUnits > 2 ) {
			positionSeconds = Number(timePositionUnits[0] * 3600) + Number(timePositionUnits[1] * 60) + Number(timePositionUnits[2]);
		} else {
			positionSeconds = Number(timePositionUnits[0] * 60) + Number(timePositionUnits[1]);
		}
		
		timeArray[0] = durationSeconds;
		timeArray[1] = positionSeconds;
		
		return timeArray;

	}

	//****************************************//
	//           start track timer            //
	//****************************************//
	function startTrackTimer() {

		if ( preferences.animateTimer.value == 0 ) { return }

		suppressUpdates();

		var timeArray = getTrackTimeArray();

		while ( timeArray[0] == "NaN" || timeArray[1] == "NaN" ) {
			timeArray = getTrackTimeArray();
		}

		var remainingTimeMS = ( timeArray[0] - timeArray[1] ) * 1000;
		
		if ( remainingTimeMS >= 0 ) {

			moveTimer[0] = new MoveAnimation( wmpTimePanel, 26, 32, remainingTimeMS, animator.kEaseNone );
			moveTimer[1] = new MoveAnimation( wmpTimeDisplay, 53, 47, remainingTimeMS, animator.kEaseNone );
			moveTimer[2] = new MoveAnimation( wmpTimeDisplayShadow, 54, 48, remainingTimeMS, animator.kEaseNone );
			moveTimer[3] = new MoveAnimation( wmpTimeShine, 26, 32, remainingTimeMS, animator.kEaseNone );
	
			animator.start( moveTimer );

			isTimerAnimRunning = true;

		}

		resumeUpdates();
	}
	
	//****************************************//
	//           reset track timer            //
	//****************************************//
	function resetTrackTimer() {

		wmpTimeDisplay.data = "00:00";
		wmpTimeDisplayShadow.data = "00:00";

		suppressUpdates();
		
		try {
			moveTimer[0].kill();
			moveTimer[1].kill();
			moveTimer[2].kill();
			moveTimer[3].kill();
		} catch(e) { print(e.message) }

		moveTimer = null;
		moveTimer = new Array();

		moveTimer[0] = new MoveAnimation( wmpTimePanel, 185, 32, 200, animator.kEaseNone );
		moveTimer[1] = new MoveAnimation( wmpTimeDisplay, 212, 47, 200, animator.kEaseNone );
		moveTimer[2] = new MoveAnimation( wmpTimeDisplayShadow, 213, 48, 200, animator.kEaseNone );
		moveTimer[3] = new MoveAnimation( wmpTimeShine, 185, 32, 200, animator.kEaseNone );
	
		animator.runUntilDone( moveTimer );

		moveTimer = null;
		moveTimer = new Array();

		isTimerAnimRunning = false;

		resumeUpdates();

		wmpTimeDisplay.data = "";
		wmpTimeDisplayShadow.data = "";

	}

	//****************************************//
	//        media library sub-class         //
	//****************************************//	
	function wmp_MediaLibrary() {
	
		this.wmpMediaCollection = wmpPlayer.mediaCollection;
		this.wmpAudioPlaylist;
		
		this.refresh = function() {
			this.wmpAudioPlaylist = this.wmpMediaCollection.getByAttribute("MediaType", "audio");
		}
	
		this.getAudioPlaylist_All = function() {

			var resultIndex = new Array();
			var itemInfo = new Array();

			for ( var i = 0; i < this.wmpAudioPlaylist.count; i++ ) {

				var mediaItem = this.wmpAudioPlaylist.Item(i);

				var itemInfo = new Array();

				itemInfo[0] = mediaItem.getItemInfo("Title");
				itemInfo[1] = mediaItem.getItemInfo("Author");
				itemInfo[2] = mediaItem.getItemInfo("WM/AlbumTitle");
				itemInfo[3] = mediaItem.getItemInfo("SourceURL");

				resultIndex.push(itemInfo);
			}
			return resultIndex;
		}
	
		this.getAudioPlaylist_Match = function( attributeName, searchText ) {
			
			var resultIndex = new Array();

			searchText = searchText.toLowerCase();
	
			for ( var i = 0; i < this.wmpAudioPlaylist.count; i++ ) {

				var mediaItem = this.wmpAudioPlaylist.Item(i);

				var searchItem = mediaItem.getItemInfo(attributeName);
				searchItem = searchItem.toLowerCase();

				var sPos = searchItem.indexOf(searchText);

				if ( sPos > -1 ) {

					var itemInfo = new Array();

					itemInfo[0] = mediaItem.getItemInfo("Title");
					itemInfo[1] = mediaItem.getItemInfo("Author");
					itemInfo[2] = mediaItem.getItemInfo("WM/AlbumTitle");
					itemInfo[3] = mediaItem.getItemInfo("SourceURL");

					resultIndex.push(itemInfo) }
			}
			
			return resultIndex;
		}

		this.getAudioPlaylist_CDrom = function( cdDrive ) {
			
			var resultIndex = new Array();
			var CDrom = wmpCDromCollection.Item(cdDrive);

			for ( var i = 0; i < CDrom.Playlist.count; i++ ) {

				var mediaItem = CDrom.Playlist.Item(i);

				var itemInfo = new Array();

				itemInfo[0] = mediaItem.getItemInfo("Title");
				itemInfo[1] = mediaItem.getItemInfo("Author");
				itemInfo[2] = mediaItem.getItemInfo("WM/AlbumTitle");
				itemInfo[3] = mediaItem.getItemInfo("SourceURL");

				resultIndex.push(itemInfo);
			}
			
			return resultIndex;		
		}
		
		this.getCDromDrives = function() {

			var resultString = new String();
			for ( var i = 0; i < wmpCDromCollection.count; i++ ) {
				var CDrom = wmpCDromCollection.Item(i);
				resultString += CDrom.driveSpecifier;
			}
			return resultString;
		}
		
		this.addAudioItem = function( filePath ) {

			// add the item
			var mediaItem = this.wmpMediaCollection.add(filePath);

			var itemInfo = new Array();

			itemInfo[0] = mediaItem.getItemInfo("Title");
			itemInfo[1] = mediaItem.getItemInfo("Author");
			itemInfo[2] = mediaItem.getItemInfo("WM/AlbumTitle");
			itemInfo[3] = mediaItem.getItemInfo("SourceURL");

			return itemInfo;
		}

		this.quit = function() {
			this.wmpAudioPlaylist = null;
			this.wmpMediaCollection = null;
		}

	}

	//****************************************//
	//     search display item sub-class      //
	//****************************************//
	function wmp_MediaLibraryItem( pl_Index, ml_ItemInfo, arrayIndex ) {
		
		this.MLI_Info = new Text(wmpMediaLibraryWindow);

		this.MLI_Info.font = "Arial";
		this.MLI_Info.style = "bold";
		this.MLI_Info.size = 10;
		this.MLI_Info.color = "#FFFFFF";
		this.MLI_Info.data = ml_ItemInfo[0] + " : " + ml_ItemInfo[1] + " : " + ml_ItemInfo[2] + " : " + ml_ItemInfo[3];
		this.MLI_Info.width = 172;
		this.MLI_Info.scrolling = "autoLeft";
		this.MLI_Info.hOffset = 28;
		this.MLI_Info.vOffset = 90 + ( 12 * arrayIndex );
		this.MLI_Info.onMouseUp = "wmp_currentIndex=" + pl_Index + ";wmpPlayer__Play(1);";
		this.MLI_Info.opacity = 255;

		this.removeItem = function() { delete this.MLI_Info }

	}

	//****************************************//
	//            shutdown widget             //
	//****************************************//
	function wmpPlayer___Unload() {

		// stop playback and destroy all objects
		wmpControls.stop();

		wmp_playlistArray = null;
		tmpPlaylistArray = null;
		wmpMediaLibrary.quit();
		wmpMediaLibrary = null;
		wmpSettings = null;
		wmpControls = null;
	
		COM.disconnectObject( wmpPlayer );
		wmpPlayer = null;

	}




<!-- ----------------------------------------------------------------- -->